#ifndef LIBWCCL_PARSER_PARSER_H
#define LIBWCCL_PARSER_PARSER_H

#include "ANTLRLexer.hpp"
#include "ANTLRParser.hpp"

// ----------------------------------------------------------------------------
#include <sstream>

// ----------------------------------------------------------------------------
#include <libcorpus2/tagset.h>

// ----------------------------------------------------------------------------
#include <libwccl/variables.h>
#include <libwccl/values/strset.h>

// exceptions
#include <libwccl/parser/ParserException.h>

// ----------------------------------------------------------------------------

class Parser {
public:
	Parser(const Corpus2::Tagset&);
	~Parser();

	// ---------------------------------------------------------------------------
	// methods for parsing string operator
	boost::shared_ptr<Wccl::Function<Wccl::StrSet> > 
		parseStringOperator(const std::string&) const;
	boost::shared_ptr<Wccl::Function<Wccl::StrSet> > 
		parseStringOperator(std::istream&     ) const;

private:
	const Corpus2::Tagset &tagset;
};

#endif // LIBWCCL_PARSER_PARSER_H
